curl --request POST \ --url https://api.egp.scale.com/v4/agents/execute \ --header 'Content-Type: application/json' \ --data @- <<EOF{ "tools": [ { "name": "<string>", "description": "<string>", "arguments": { "type": "object", "properties": {}, "required": [ "<string>" ] } } ], "messages": [ { "content": "<string>", "role": "user" } ], "model_parameters": { "temperature": 0.2 }, "instructions": "You are an AI assistant that helps users with their questions. You can answer questions directly or acquire information from any of the attached tools to assist you. Always answer the user's most recent query to the best of your knowledge.\n\nWhen asked about what tools are available, you must list each attached tool's name and description. When asked about what you can do, mention that in addition to your normal capabilities, you can also use the attached tools by listing their names and descriptions. You cannot use any other tools other than the ones provided to you explicitly."}EOF
import requests
url = "https://api.egp.scale.com/v4/agents/execute"
payload = {
"tools": [
{
"name": "<string>",
"description": "<string>",
"arguments": {
"type": "object",
"properties": {},
"required": ["<string>"]
}
}
],
"messages": [
{
"content": "<string>",
"role": "user"
}
],
"model_parameters": { "temperature": 0.2 },
"instructions": "You are an AI assistant that helps users with their questions. You can answer questions directly or acquire information from any of the attached tools to assist you. Always answer the user's most recent query to the best of your knowledge.
When asked about what tools are available, you must list each attached tool's name and description. When asked about what you can do, mention that in addition to your normal capabilities, you can also use the attached tools by listing their names and descriptions. You cannot use any other tools other than the ones provided to you explicitly."
}
headers = {"Content-Type": "application/json"}
response = requests.post(url, json=payload, headers=headers)
print(response.text)
const options = {
method: 'POST',
headers: {'Content-Type': 'application/json'},
body: JSON.stringify({
tools: [
{
name: '<string>',
description: '<string>',
arguments: {type: 'object', properties: {}, required: ['<string>']}
}
],
messages: [{content: '<string>', role: 'user'}],
model_parameters: {temperature: 0.2},
instructions: 'You are an AI assistant that helps users with their questions. You can answer questions directly or acquire information from any of the attached tools to assist you. Always answer the user\'s most recent query to the best of your knowledge.\n\nWhen asked about what tools are available, you must list each attached tool\'s name and description. When asked about what you can do, mention that in addition to your normal capabilities, you can also use the attached tools by listing their names and descriptions. You cannot use any other tools other than the ones provided to you explicitly.'
})
};
fetch('https://api.egp.scale.com/v4/agents/execute', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.egp.scale.com/v4/agents/execute",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'tools' => [
[
'name' => '<string>',
'description' => '<string>',
'arguments' => [
'type' => 'object',
'properties' => [
],
'required' => [
'<string>'
]
]
]
],
'messages' => [
[
'content' => '<string>',
'role' => 'user'
]
],
'model_parameters' => [
'temperature' => 0.2
],
'instructions' => 'You are an AI assistant that helps users with their questions. You can answer questions directly or acquire information from any of the attached tools to assist you. Always answer the user\'s most recent query to the best of your knowledge.
When asked about what tools are available, you must list each attached tool\'s name and description. When asked about what you can do, mention that in addition to your normal capabilities, you can also use the attached tools by listing their names and descriptions. You cannot use any other tools other than the ones provided to you explicitly.'
]),
CURLOPT_HTTPHEADER => [
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}
package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.egp.scale.com/v4/agents/execute"
payload := strings.NewReader("{\n \"tools\": [\n {\n \"name\": \"<string>\",\n \"description\": \"<string>\",\n \"arguments\": {\n \"type\": \"object\",\n \"properties\": {},\n \"required\": [\n \"<string>\"\n ]\n }\n }\n ],\n \"messages\": [\n {\n \"content\": \"<string>\",\n \"role\": \"user\"\n }\n ],\n \"model_parameters\": {\n \"temperature\": 0.2\n },\n \"instructions\": \"You are an AI assistant that helps users with their questions. You can answer questions directly or acquire information from any of the attached tools to assist you. Always answer the user's most recent query to the best of your knowledge.\\n\\nWhen asked about what tools are available, you must list each attached tool's name and description. When asked about what you can do, mention that in addition to your normal capabilities, you can also use the attached tools by listing their names and descriptions. You cannot use any other tools other than the ones provided to you explicitly.\"\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}
HttpResponse<String> response = Unirest.post("https://api.egp.scale.com/v4/agents/execute")
.header("Content-Type", "application/json")
.body("{\n \"tools\": [\n {\n \"name\": \"<string>\",\n \"description\": \"<string>\",\n \"arguments\": {\n \"type\": \"object\",\n \"properties\": {},\n \"required\": [\n \"<string>\"\n ]\n }\n }\n ],\n \"messages\": [\n {\n \"content\": \"<string>\",\n \"role\": \"user\"\n }\n ],\n \"model_parameters\": {\n \"temperature\": 0.2\n },\n \"instructions\": \"You are an AI assistant that helps users with their questions. You can answer questions directly or acquire information from any of the attached tools to assist you. Always answer the user's most recent query to the best of your knowledge.\\n\\nWhen asked about what tools are available, you must list each attached tool's name and description. When asked about what you can do, mention that in addition to your normal capabilities, you can also use the attached tools by listing their names and descriptions. You cannot use any other tools other than the ones provided to you explicitly.\"\n}")
.asString();
require 'uri'
require 'net/http'
url = URI("https://api.egp.scale.com/v4/agents/execute")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Content-Type"] = 'application/json'
request.body = "{\n \"tools\": [\n {\n \"name\": \"<string>\",\n \"description\": \"<string>\",\n \"arguments\": {\n \"type\": \"object\",\n \"properties\": {},\n \"required\": [\n \"<string>\"\n ]\n }\n }\n ],\n \"messages\": [\n {\n \"content\": \"<string>\",\n \"role\": \"user\"\n }\n ],\n \"model_parameters\": {\n \"temperature\": 0.2\n },\n \"instructions\": \"You are an AI assistant that helps users with their questions. You can answer questions directly or acquire information from any of the attached tools to assist you. Always answer the user's most recent query to the best of your knowledge.\\n\\nWhen asked about what tools are available, you must list each attached tool's name and description. When asked about what you can do, mention that in addition to your normal capabilities, you can also use the attached tools by listing their names and descriptions. You cannot use any other tools other than the ones provided to you explicitly.\"\n}"
response = http.request(request)
puts response.read_body
### Description
Executes one Agent inference step. Given a list of messages and a list of tools to ask for help from, the Agent will either respond with a final answer directly or ask the user to execute a tool to provide more information.
### Details
An Agent is a component that utilizes a Language Model (LLM) as an interpreter and decision maker. Unlike asking an LLM for a direct response, communicating with an agent consists of a running dialogue where an agent can optionally ask the user to execute specialized tools for specific tasks, such as calculations, web searches, or accessing custom data from private knowledge bases.
An agent is designed to be stateless, emitting outputs one step at a time. This means that client-side applications are responsible for managing message history, tool execution, and responses. This grants users greater flexibility to write and execute custom tools and maintain explicit control over their message history.
#### Message Types
- `User Message`: A message from the user to the agent.
- `System Message`: An informational text message from the system to guide the agent. It is not a user message or agent message because it did not come from either entity.
- `Agent Message`: A message from the agent to the client. It will contain either a final answer as `content` or a request for the user to execute a tool as a `tool_request`.
- `Tool Message`: A message from the user to the agent that contains the output of a tool execution. The tool message will be processed by the agent and the agent will respond with either a final answer or another tool request.
#### Agent Instructions
Instructions are used to guide the agent's decision making process and output generation.
Good prompt engineering is crucial to getting performant results from the agent. If you are having trouble getting the agent to perform well, try writing more specific instructions before trying more expensive techniques such as swapping in other models or finetuning the underlying LLM.
For example, the default instructions we set for the agent are the following:
> You are an AI assistant that helps users with their questions. You can answer questions directly or acquire information from any of the attached tools to assist you. Always answer the user's most recent query to the best of your knowledge.<br>
> When asked about what tools are available, you must list each attached tool's name and description. When asked about what you can do, mention that in addition to your normal capabilities, you can also use the attached tools by listing their names and descriptions. You cannot use any other tools other than the ones provided to you explicitly.
### Restrictions and Limits
**Message Limits**:
- The message list is not limited by length, but by the context limit of the underlying language model. If you are getting an error regarding the underlying model's context limit, try using a memory strategy to condense the input messages.
**Model Restrictions**:
- Currently, only closed source models like GPT and Claude are supported due to the limitations of open source models when it comes to tool selection, generating tool arguments in valid JSON, and planning out multi-step tool execution. Specialized fine-tuning will likely be required to make open source models compatible with agents.
POST
/
v4
/
agents
/
execute
Execute Agent
curl --request POST \ --url https://api.egp.scale.com/v4/agents/execute \ --header 'Content-Type: application/json' \ --data @- <<EOF{ "tools": [ { "name": "<string>", "description": "<string>", "arguments": { "type": "object", "properties": {}, "required": [ "<string>" ] } } ], "messages": [ { "content": "<string>", "role": "user" } ], "model_parameters": { "temperature": 0.2 }, "instructions": "You are an AI assistant that helps users with their questions. You can answer questions directly or acquire information from any of the attached tools to assist you. Always answer the user's most recent query to the best of your knowledge.\n\nWhen asked about what tools are available, you must list each attached tool's name and description. When asked about what you can do, mention that in addition to your normal capabilities, you can also use the attached tools by listing their names and descriptions. You cannot use any other tools other than the ones provided to you explicitly."}EOF
import requests
url = "https://api.egp.scale.com/v4/agents/execute"
payload = {
"tools": [
{
"name": "<string>",
"description": "<string>",
"arguments": {
"type": "object",
"properties": {},
"required": ["<string>"]
}
}
],
"messages": [
{
"content": "<string>",
"role": "user"
}
],
"model_parameters": { "temperature": 0.2 },
"instructions": "You are an AI assistant that helps users with their questions. You can answer questions directly or acquire information from any of the attached tools to assist you. Always answer the user's most recent query to the best of your knowledge.
When asked about what tools are available, you must list each attached tool's name and description. When asked about what you can do, mention that in addition to your normal capabilities, you can also use the attached tools by listing their names and descriptions. You cannot use any other tools other than the ones provided to you explicitly."
}
headers = {"Content-Type": "application/json"}
response = requests.post(url, json=payload, headers=headers)
print(response.text)
const options = {
method: 'POST',
headers: {'Content-Type': 'application/json'},
body: JSON.stringify({
tools: [
{
name: '<string>',
description: '<string>',
arguments: {type: 'object', properties: {}, required: ['<string>']}
}
],
messages: [{content: '<string>', role: 'user'}],
model_parameters: {temperature: 0.2},
instructions: 'You are an AI assistant that helps users with their questions. You can answer questions directly or acquire information from any of the attached tools to assist you. Always answer the user\'s most recent query to the best of your knowledge.\n\nWhen asked about what tools are available, you must list each attached tool\'s name and description. When asked about what you can do, mention that in addition to your normal capabilities, you can also use the attached tools by listing their names and descriptions. You cannot use any other tools other than the ones provided to you explicitly.'
})
};
fetch('https://api.egp.scale.com/v4/agents/execute', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.egp.scale.com/v4/agents/execute",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'tools' => [
[
'name' => '<string>',
'description' => '<string>',
'arguments' => [
'type' => 'object',
'properties' => [
],
'required' => [
'<string>'
]
]
]
],
'messages' => [
[
'content' => '<string>',
'role' => 'user'
]
],
'model_parameters' => [
'temperature' => 0.2
],
'instructions' => 'You are an AI assistant that helps users with their questions. You can answer questions directly or acquire information from any of the attached tools to assist you. Always answer the user\'s most recent query to the best of your knowledge.
When asked about what tools are available, you must list each attached tool\'s name and description. When asked about what you can do, mention that in addition to your normal capabilities, you can also use the attached tools by listing their names and descriptions. You cannot use any other tools other than the ones provided to you explicitly.'
]),
CURLOPT_HTTPHEADER => [
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}
package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.egp.scale.com/v4/agents/execute"
payload := strings.NewReader("{\n \"tools\": [\n {\n \"name\": \"<string>\",\n \"description\": \"<string>\",\n \"arguments\": {\n \"type\": \"object\",\n \"properties\": {},\n \"required\": [\n \"<string>\"\n ]\n }\n }\n ],\n \"messages\": [\n {\n \"content\": \"<string>\",\n \"role\": \"user\"\n }\n ],\n \"model_parameters\": {\n \"temperature\": 0.2\n },\n \"instructions\": \"You are an AI assistant that helps users with their questions. You can answer questions directly or acquire information from any of the attached tools to assist you. Always answer the user's most recent query to the best of your knowledge.\\n\\nWhen asked about what tools are available, you must list each attached tool's name and description. When asked about what you can do, mention that in addition to your normal capabilities, you can also use the attached tools by listing their names and descriptions. You cannot use any other tools other than the ones provided to you explicitly.\"\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}
HttpResponse<String> response = Unirest.post("https://api.egp.scale.com/v4/agents/execute")
.header("Content-Type", "application/json")
.body("{\n \"tools\": [\n {\n \"name\": \"<string>\",\n \"description\": \"<string>\",\n \"arguments\": {\n \"type\": \"object\",\n \"properties\": {},\n \"required\": [\n \"<string>\"\n ]\n }\n }\n ],\n \"messages\": [\n {\n \"content\": \"<string>\",\n \"role\": \"user\"\n }\n ],\n \"model_parameters\": {\n \"temperature\": 0.2\n },\n \"instructions\": \"You are an AI assistant that helps users with their questions. You can answer questions directly or acquire information from any of the attached tools to assist you. Always answer the user's most recent query to the best of your knowledge.\\n\\nWhen asked about what tools are available, you must list each attached tool's name and description. When asked about what you can do, mention that in addition to your normal capabilities, you can also use the attached tools by listing their names and descriptions. You cannot use any other tools other than the ones provided to you explicitly.\"\n}")
.asString();
require 'uri'
require 'net/http'
url = URI("https://api.egp.scale.com/v4/agents/execute")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Content-Type"] = 'application/json'
request.body = "{\n \"tools\": [\n {\n \"name\": \"<string>\",\n \"description\": \"<string>\",\n \"arguments\": {\n \"type\": \"object\",\n \"properties\": {},\n \"required\": [\n \"<string>\"\n ]\n }\n }\n ],\n \"messages\": [\n {\n \"content\": \"<string>\",\n \"role\": \"user\"\n }\n ],\n \"model_parameters\": {\n \"temperature\": 0.2\n },\n \"instructions\": \"You are an AI assistant that helps users with their questions. You can answer questions directly or acquire information from any of the attached tools to assist you. Always answer the user's most recent query to the best of your knowledge.\\n\\nWhen asked about what tools are available, you must list each attached tool's name and description. When asked about what you can do, mention that in addition to your normal capabilities, you can also use the attached tools by listing their names and descriptions. You cannot use any other tools other than the ones provided to you explicitly.\"\n}"
response = http.request(request)
puts response.read_body
The list of specs of tools that the agent can use. Each spec must contain a name key set to the name of the tool, a description key set to the description of the tool, and an arguments key set to a JSON Schema compliant object describing the tool arguments.
The name and description of each tool is used by the agent to decide when to use certain tools. Because some queries are complex and may require multiple tools to complete, it is important to make these descriptions as informative as possible. If a tool is not being chosen when it should, it is common practice to tune the description of the tool to make it more apparent to the agent when the tool can be used effectively.
The memory strategy to use for the agent. A memory strategy is a way to prevent the underlying LLM's context limit from being exceeded. Each memory strategy uses a different technique to condense the input message list into a smaller payload for the underlying LLM.
We only support the Last K memory strategy right now, but will be adding new strategies soon.
default:You are an AI assistant that helps users with their questions. You can answer questions directly or acquire information from any of the attached tools to assist you. Always answer the user's most recent query to the best of your knowledge.
When asked about what tools are available, you must list each attached tool's name and description. When asked about what you can do, mention that in addition to your normal capabilities, you can also use the attached tools by listing their names and descriptions. You cannot use any other tools other than the ones provided to you explicitly.
The initial instructions to provide to the agent.
Use this to guide the agent to act in more specific ways. For example, if you have specific rules you want to restrict the agent to follow you can specify them here. For example, if I want the agent to always use certain tools before others, I can write that rule in these instructions.
Good prompt engineering is crucial to getting performant results from the agent. If you are having trouble getting the agent to perform well, try writing more specific instructions here before trying more expensive techniques such as swapping in other models or finetuning the underlying LLM.
The context will contain a key for each action that the agent can perform. However, only the key corresponding to the action that the agent actually performed will have a populated value. The rest of the values will be null.
Context object containing the output payload. This will contain a key for all actions that the agent can perform. However, only the key corresponding to the action that the agent performed have a populated value. The rest of the values will be null.
Show child attributes
{"docsConfig":{"theme":"mint","$schema":"https://mintlify.com/docs.json","name":"Scale AI","colors":{"primary":"#3f2e7b","light":"#ca62ff","dark":"#3f2e7b"},"logo":{"light":"https://mintcdn.com/scalegp/TBmst1qiYXwYqUB5/logo/light.png?fit=max\u0026auto=format\u0026n=TBmst1qiYXwYqUB5\u0026q=85\u0026s=46027042c16b373ac463148db5ad1d6b","dark":"https://mintcdn.com/scalegp/TBmst1qiYXwYqUB5/logo/dark.png?fit=max\u0026auto=format\u0026n=TBmst1qiYXwYqUB5\u0026q=85\u0026s=02733f39d684d796ec742853eabf0de5"},"favicon":"https://mintcdn.com/scalegp/1vQnbXFkjbQbcgd1/favicon.png?fit=max\u0026auto=format\u0026n=1vQnbXFkjbQbcgd1\u0026q=85\u0026s=f52c84ba46a7cca58551673616dabe9c","background":{"decoration":"windows"},"navbar":{"links":[],"primary":{"type":"button","label":"Platform","href":"https://app.sgp.scale.com/"}},"footer":{"socials":{"x":"https://x.com/scale_ai","facebook":"https://www.facebook.com/scaleapi","linkedin":"https://www.linkedin.com/company/scaleai"}},"styling":{"latex":false},"navigation":{"pages":[]}},"deployment":{"deploymentMetadataValue":{"subdomain":"scalegp","hasAudioNarration":false,"actualSubdomain":"scalegp","customDomains":["docs.gp.scale.com"],"gitSource":{"type":"github","owner":"scaleapi","repo":"sgp-docs","deployBranch":"main","contentDirectory":"","isPrivate":false,"mountPath":"","label":""},"chroma":{"liveDeploymentHistoryId":"6abeb90f3a8b8379c1eaf648","collectionId":"437f531c-55bf-41b5-8f5d-4e63781df61e","schemaVersion":"v3","latestBuiltDeploymentHistoryId":"6abeb90f3a8b8379c1eaf648"},"entitlements":{"AI_CHAT":{"status":"ENABLED"},"REMOVE_BRANDING":{"status":"ENABLED"},"CONTEXTUAL_FEEDBACK":{"status":"ENABLED"},"CODE_SNIPPET_FEEDBACK":{"status":"ENABLED"},"WEB_MCP":{"status":"ENABLED"},"NARRATION":{"status":"ENABLED"}},"buildId":"6abeb90f3a8b8379c1eaf648","clientVersion":"0.0.4045","searchFilterCounts":[{"language":"default","tag":"API Reference","count":235},{"language":"default","tag":"AgentOps API","count":141},{"language":"default","tag":"Guides","count":131},{"language":"default","tag":"Agentex API","count":94},{"language":"default","tag":"Evaluations","count":72},{"language":"default","tag":"Dex API","count":48},{"language":"default","tag":"Agents","count":41},{"language":"default","tag":"Evaluation Datasets","count":34},{"language":"default","tag":"Models","count":32},{"language":"default","tag":"Knowledge Bases","count":31}]},"assistantConfig":{},"basePath":"","hasChatPermissions":true,"hasWebMcpPermissions":true,"toggles":[{"name":"kill-isr","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"agent-mintlify-slack","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"agent-integrations-settings","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automations-pr-grouping","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"custom-prefix","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"analytics-v7","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"user-flows-analytics","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"no-publish-flow","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-onboarding","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"llms-txt-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"snapshot-serving-live","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"stripTemperatureMiddleware","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"support-platform-pylon-zendesk","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"snapshot-serving","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"instant-rollback","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"granular-notifications-server","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"granular-notifications","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automations-fable","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"fixed-ai-action-pricing","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automation-resolve-merge-conflict","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"scoped-publishing","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"mintql","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"page-level-analytics","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-version-history-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"billing-page-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"full-page-search","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workspace-projects","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"assistant-v5","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"byok-sep-25","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"fork-pr-previews","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"revalidation-jwt","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"vite-origin","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"billing-updated-9-15","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-sso-scim","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"hobby-abuse-scan","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"dashboard-inbox","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-signup","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"turbopuffer-dual-write","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-enabled","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"approve-review-flow","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"sso-setup-deadline-banner","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false}],"googleFontsInlined":false},"customCss":[{"filePath":"styles.css","content":"@font-face{font-family:'Aeonik';src:url(https://fonts.gstatic.com/s/inter/v18/UcC73FwrK3iLTeHuS_nVMrMxCp50SjIa1ZL7W0Q5nw.woff2);font-weight:400;font-style:normal;font-display:swap}h1,h2,h3{font-family:'aeonik';letter-spacing:normal!important}"}],"page":{"pagePath":"reference/v4/agents/execute-agent","slug":"/reference/v4/agents/execute-agent","pageMetadata":{"title":"Execute Agent","description":"### Description\nExecutes one Agent inference step. Given a list of messages and a list of tools to ask for help from, the Agent will either respond with a final answer directly or ask the user to execute a tool to provide more information.\n\n### Details\nAn Agent is a component that utilizes a Language Model (LLM) as an interpreter and decision maker. Unlike asking an LLM for a direct response, communicating with an agent consists of a running dialogue where an agent can optionally ask the user to execute specialized tools for specific tasks, such as calculations, web searches, or accessing custom data from private knowledge bases.\n\nAn agent is designed to be stateless, emitting outputs one step at a time. This means that client-side applications are responsible for managing message history, tool execution, and responses. This grants users greater flexibility to write and execute custom tools and maintain explicit control over their message history.\n\n#### Message Types\n- `User Message`: A message from the user to the agent.\n- `System Message`: An informational text message from the system to guide the agent. It is not a user message or agent message because it did not come from either entity.\n- `Agent Message`: A message from the agent to the client. It will contain either a final answer as `content` or a request for the user to execute a tool as a `tool_request`.\n- `Tool Message`: A message from the user to the agent that contains the output of a tool execution. The tool message will be processed by the agent and the agent will respond with either a final answer or another tool request.\n\n#### Agent Instructions\nInstructions are used to guide the agent's decision making process and output generation.\n\nGood prompt engineering is crucial to getting performant results from the agent. If you are having trouble getting the agent to perform well, try writing more specific instructions before trying more expensive techniques such as swapping in other models or finetuning the underlying LLM.\n\nFor example, the default instructions we set for the agent are the following:\n\n> You are an AI assistant that helps users with their questions. You can answer questions directly or acquire information from any of the attached tools to assist you. Always answer the user's most recent query to the best of your knowledge.\u003cbr>\n> When asked about what tools are available, you must list each attached tool's name and description. When asked about what you can do, mention that in addition to your normal capabilities, you can also use the attached tools by listing their names and descriptions. You cannot use any other tools other than the ones provided to you explicitly.\n\n\n### Restrictions and Limits\n**Message Limits**:\n - The message list is not limited by length, but by the context limit of the underlying language model. If you are getting an error regarding the underlying model's context limit, try using a memory strategy to condense the input messages.\n\n**Model Restrictions**:\n - Currently, only closed source models like GPT and Claude are supported due to the limitations of open source models when it comes to tool selection, generating tool arguments in valid JSON, and planning out multi-step tool execution. Specialized fine-tuning will likely be required to make open source models compatible with agents.","deprecated":null,"version":null,"openapi":"https://api.sgp.scale.com/openapi-versions/v4/openapi.json post /v4/agents/execute","href":"/reference/v4/agents/execute-agent","autogeneratedByOpenApi":true},"description":"### Description\nExecutes one Agent inference step. Given a list of messages and a list of tools to ask for help from, the Agent will either respond with a final answer directly or ask the user to execute a tool to provide more information.\n\n### Details\nAn Agent is a component that utilizes a Language Model (LLM) as an interpreter and decision maker. Unlike asking an LLM for a direct response, communicating with an agent consists of a running dialogue where an agent can optionally ask the user to execute specialized tools for specific tasks, such as calculations, web searches, or accessing custom data from private knowledge bases.\n\nAn agent is designed to be stateless, emitting outputs one step at a time. This means that client-side applications are responsible for managing message history, tool execution, and responses. This grants users greater flexibility to write and execute custom tools and maintain explicit control over their message history.\n\n#### Message Types\n- `User Message`: A message from the user to the agent.\n- `System Message`: An informational text message from the system to guide the agent. It is not a user message or agent message because it did not come from either entity.\n- `Agent Message`: A message from the agent to the client. It will contain either a final answer as `content` or a request for the user to execute a tool as a `tool_request`.\n- `Tool Message`: A message from the user to the agent that contains the output of a tool execution. The tool message will be processed by the agent and the agent will respond with either a final answer or another tool request.\n\n#### Agent Instructions\nInstructions are used to guide the agent's decision making process and output generation.\n\nGood prompt engineering is crucial to getting performant results from the agent. If you are having trouble getting the agent to perform well, try writing more specific instructions before trying more expensive techniques such as swapping in other models or finetuning the underlying LLM.\n\nFor example, the default instructions we set for the agent are the following:\n\n> You are an AI assistant that helps users with their questions. You can answer questions directly or acquire information from any of the attached tools to assist you. Always answer the user's most recent query to the best of your knowledge.\u003cbr>\n> When asked about what tools are available, you must list each attached tool's name and description. When asked about what you can do, mention that in addition to your normal capabilities, you can also use the attached tools by listing their names and descriptions. You cannot use any other tools other than the ones provided to you explicitly.\n\n\n### Restrictions and Limits\n**Message Limits**:\n - The message list is not limited by length, but by the context limit of the underlying language model. If you are getting an error regarding the underlying model's context limit, try using a memory strategy to condense the input messages.\n\n**Model Restrictions**:\n - Currently, only closed source models like GPT and Claude are supported due to the limitations of open source models when it comes to tool selection, generating tool arguments in valid JSON, and planning out multi-step tool execution. Specialized fine-tuning will likely be required to make open source models compatible with agents.","pageType":"default","mdx":{"mdxSource":{"compiledSource":"\"use strict\";const{Fragment:_Fragment,jsx:_jsx}=arguments[0];const{useMDXComponents:_provideComponents}=arguments[0];function _createMdxContent(props){return _jsx(_Fragment,{})}function MDXContent(props={}){const{wrapper:MDXLayout}={..._provideComponents(),...props.components};return MDXLayout?_jsx(MDXLayout,{...props,children:_jsx(_createMdxContent,{...props})}):_createMdxContent(props)}return{default:MDXContent}","frontmatter":{},"scope":{"config":{},"pageMetadata":{"title":"Execute Agent","description":"### Description\nExecutes one Agent inference step. Given a list of messages and a list of tools to ask for help from, the Agent will either respond with a final answer directly or ask the user to execute a tool to provide more information.\n\n### Details\nAn Agent is a component that utilizes a Language Model (LLM) as an interpreter and decision maker. Unlike asking an LLM for a direct response, communicating with an agent consists of a running dialogue where an agent can optionally ask the user to execute specialized tools for specific tasks, such as calculations, web searches, or accessing custom data from private knowledge bases.\n\nAn agent is designed to be stateless, emitting outputs one step at a time. This means that client-side applications are responsible for managing message history, tool execution, and responses. This grants users greater flexibility to write and execute custom tools and maintain explicit control over their message history.\n\n#### Message Types\n- `User Message`: A message from the user to the agent.\n- `System Message`: An informational text message from the system to guide the agent. It is not a user message or agent message because it did not come from either entity.\n- `Agent Message`: A message from the agent to the client. It will contain either a final answer as `content` or a request for the user to execute a tool as a `tool_request`.\n- `Tool Message`: A message from the user to the agent that contains the output of a tool execution. The tool message will be processed by the agent and the agent will respond with either a final answer or another tool request.\n\n#### Agent Instructions\nInstructions are used to guide the agent's decision making process and output generation.\n\nGood prompt engineering is crucial to getting performant results from the agent. If you are having trouble getting the agent to perform well, try writing more specific instructions before trying more expensive techniques such as swapping in other models or finetuning the underlying LLM.\n\nFor example, the default instructions we set for the agent are the following:\n\n> You are an AI assistant that helps users with their questions. You can answer questions directly or acquire information from any of the attached tools to assist you. Always answer the user's most recent query to the best of your knowledge.\u003cbr>\n> When asked about what tools are available, you must list each attached tool's name and description. When asked about what you can do, mention that in addition to your normal capabilities, you can also use the attached tools by listing their names and descriptions. You cannot use any other tools other than the ones provided to you explicitly.\n\n\n### Restrictions and Limits\n**Message Limits**:\n - The message list is not limited by length, but by the context limit of the underlying language model. If you are getting an error regarding the underlying model's context limit, try using a memory strategy to condense the input messages.\n\n**Model Restrictions**:\n - Currently, only closed source models like GPT and Claude are supported due to the limitations of open source models when it comes to tool selection, generating tool arguments in valid JSON, and planning out multi-step tool execution. Specialized fine-tuning will likely be required to make open source models compatible with agents.","deprecated":null,"version":null,"openapi":"https://api.sgp.scale.com/openapi-versions/v4/openapi.json post /v4/agents/execute","href":"/reference/v4/agents/execute-agent","autogeneratedByOpenApi":true}}},"mdxSourceWithNoJs":null},"mdxExtracts":{"tableOfContents":[],"codeExamples":{}},"jsLinks":[],"openApiReferenceData":{"operation":{"tags":["Agents"],"summary":"Execute Agent","description":"### Description\nExecutes one Agent inference step. Given a list of messages and a list of tools to ask for help from, the Agent will either respond with a final answer directly or ask the user to execute a tool to provide more information.\n\n### Details\nAn Agent is a component that utilizes a Language Model (LLM) as an interpreter and decision maker. Unlike asking an LLM for a direct response, communicating with an agent consists of a running dialogue where an agent can optionally ask the user to execute specialized tools for specific tasks, such as calculations, web searches, or accessing custom data from private knowledge bases.\n\nAn agent is designed to be stateless, emitting outputs one step at a time. This means that client-side applications are responsible for managing message history, tool execution, and responses. This grants users greater flexibility to write and execute custom tools and maintain explicit control over their message history.\n\n#### Message Types\n- `User Message`: A message from the user to the agent.\n- `System Message`: An informational text message from the system to guide the agent. It is not a user message or agent message because it did not come from either entity.\n- `Agent Message`: A message from the agent to the client. It will contain either a final answer as `content` or a request for the user to execute a tool as a `tool_request`.\n- `Tool Message`: A message from the user to the agent that contains the output of a tool execution. The tool message will be processed by the agent and the agent will respond with either a final answer or another tool request.\n\n#### Agent Instructions\nInstructions are used to guide the agent's decision making process and output generation.\n\nGood prompt engineering is crucial to getting performant results from the agent. If you are having trouble getting the agent to perform well, try writing more specific instructions before trying more expensive techniques such as swapping in other models or finetuning the underlying LLM.\n\nFor example, the default instructions we set for the agent are the following:\n\n> You are an AI assistant that helps users with their questions. You can answer questions directly or acquire information from any of the attached tools to assist you. Always answer the user's most recent query to the best of your knowledge.\u003cbr>\n> When asked about what tools are available, you must list each attached tool's name and description. When asked about what you can do, mention that in addition to your normal capabilities, you can also use the attached tools by listing their names and descriptions. You cannot use any other tools other than the ones provided to you explicitly.\n\n\n### Restrictions and Limits\n**Message Limits**:\n - The message list is not limited by length, but by the context limit of the underlying language model. If you are getting an error regarding the underlying model's context limit, try using a memory strategy to condense the input messages.\n\n**Model Restrictions**:\n - Currently, only closed source models like GPT and Claude are supported due to the limitations of open source models when it comes to tool selection, generating tool arguments in valid JSON, and planning out multi-step tool execution. Specialized fine-tuning will likely be required to make open source models compatible with agents.","operationId":"POST-V4-/v2/agents/execute","requestBody":"54b69621-5f23-43fb-9bab-354713660d93","responses":{"200":"d71e2d2e-a617-45ed-9902-84d68288cbcc","422":"2d9fd935-c102-451c-aae8-7940c77f237d"},"method":"post","type":"path","servers":["239d3ed0-e9a1-4424-90ea-9274ea35b5d0"],"security":[],"path":"/v4/agents/execute","baseUrlOptions":["https://api.egp.scale.com"],"title":"Execute Agent","codeSamples":[],"requiredOnlyExamples":false,"requestExampleType":"generated","responseExampleType":"generated"},"dependencies":{"parameters":{},"requestBody":{"content":{"application/json":{"schema":{"properties":{"model":{"type":"string","enum":["gpt-4","gpt-4-0613","gpt-4-32k","gpt-4-32k-0613","gpt-3.5-turbo","gpt-3.5-turbo-0613","gpt-3.5-turbo-16k","gpt-3.5-turbo-16k-0613","claude-instant-1","claude-instant-1.1","claude-2","claude-2.0"],"title":"Model","description":"The ID of the model to use for the agent. We only support the models listed here so far.","isRequired":true,"uniqueKey":"model","typeLabel":"enum\u003cstring>"},"tools":{"items":{"properties":{"name":{"type":"string","pattern":"^[a-zA-Z0-9_-]{1,64}$","title":"Name","description":"Name of the tool.\n\nA tool is a function that the _client application_ has at its disposal. The tool name is the name the client wishes the Agent to use to refer to this function when it decides if it wants the user to use the tool or not. Itmust be unique amongst the set of tools provided in a single API call.","isRequired":true,"uniqueKey":"tools.items.[INDEX].name","typeLabel":"string"},"description":{"type":"string","title":"Description","description":"Description of the tool.\n\nBecause some queries are complex and may require multiple tools to complete, it is important to make these descriptions as informative as possible. If a tool is not being chosen when it should, it is common practice to tune the description of the tool to make it more apparent to the agent when the tool can be used effectively.","isRequired":true,"uniqueKey":"tools.items.[INDEX].description","typeLabel":"string"},"arguments":{"properties":{"type":{"type":"string","const":"object","title":"Type","description":"Type of argument. Currently only \"object\" is supported","isRequired":true,"uniqueKey":"tools.items.[INDEX].arguments.type","typeLabel":"string"},"properties":{"additionalProperties":{"properties":{"type":{"type":"string","enum":["string","number","integer","boolean","object","array","null"],"title":"Type","description":"The argument's type.\n\nThe type is used to help the Agent generate valid arguments for the tool.\n\nFor more information about types, see: https://json-schema.org/understanding-json-schema/reference/type.html#type-specific-keywords","isRequired":true,"uniqueKey":"tools.items.[INDEX].arguments.properties.additionalProperties.type","typeLabel":"enum\u003cstring>"},"description":{"type":"string","title":"Description","description":"Description of what the argument is used for.\n\nThis description is used to help the Agent generate sensible arguments for the tool. It is very important that this description is succinct, clear, and accurate.","isRequired":true,"uniqueKey":"tools.items.[INDEX].arguments.properties.additionalProperties.description","typeLabel":"string"},"default":{"title":"Default","description":"A default value for the argument if unspecified.","type":"string","uniqueKey":"tools.items.[INDEX].arguments.properties.additionalProperties.default","typeLabel":"string"},"examples":{"title":"Examples","description":"Example values demonstrating how the argument should look.\n\nThis can be used to help the agent understand what a valid argument should look like.","items":{"type":"string","uniqueKey":"tools.items.[INDEX].arguments.properties.additionalProperties.examples.items.[INDEX]","typeLabel":"string"},"type":"array","uniqueKey":"tools.items.[INDEX].arguments.properties.additionalProperties.examples","typeLabel":"string[]"}},"type":"object","required":["type","description"],"title":"property","uniqueKey":"tools.items.[INDEX].arguments.properties.additionalProperties","typeLabel":"property · object"},"type":"object","title":"Properties","description":"An object where each key is the name of a keyword argument and each value is a schema used to validate that property. Each schema must have a type and description, but can also have a default value and examples.\n\nFor more information on how to define a valid property, visit https://json-schema.org/understanding-json-schema/reference/object.html","uniqueKey":"tools.items.[INDEX].arguments.properties","typeLabel":"Properties · object"},"required":{"title":"Required","description":"List of required property names.","items":{"type":"string","uniqueKey":"tools.items.[INDEX].arguments.required.items.[INDEX]","typeLabel":"string"},"type":"array","uniqueKey":"tools.items.[INDEX].arguments.required","typeLabel":"string[]"}},"type":"object","required":["type"],"title":"ToolArguments","description":"An JSON Schema-compliant schema for the tool arguments. To describe a function that accepts no parameters, provide the value `{\"type\": \"\"object\", \"properties\": {}}`.\n\nFor more information on how to define a valid JSON Schema object, visit https://json-schema.org/understanding-json-schema/reference/object.html","isRequired":true,"uniqueKey":"tools.items.[INDEX].arguments","typeLabel":"ToolArguments · object"}},"type":"object","required":["name","description","arguments"],"title":"Tool","uniqueKey":"tools.items.[INDEX]","typeLabel":"Tool · object"},"type":"array","title":"Tools","description":"The list of specs of tools that the agent can use. Each spec must contain a `name` key set to the name of the tool, a `description` key set to the description of the tool, and an `arguments` key set to a JSON Schema compliant object describing the tool arguments.\n\nThe name and description of each tool is used by the agent to decide when to use certain tools. Because some queries are complex and may require multiple tools to complete, it is important to make these descriptions as informative as possible. If a tool is not being chosen when it should, it is common practice to tune the description of the tool to make it more apparent to the agent when the tool can be used effectively.\n\n","isRequired":true,"uniqueKey":"tools","typeLabel":"Tool · object[]"},"messages":{"items":{"oneOf":[{"type":"object","title":"User Message","required":["content"],"properties":{"content":{"oneOf":[{"type":"string","title":"Content","description":"Input from the user. Can either be text or a list of content parts. Not all models support image content parts, or multiple parts.","isRequired":true,"uniqueKey":"messages.items.[INDEX].oneOf.0.content.oneOf.0","typeLabel":"string"},{"type":"array","items":{"oneOf":[{"type":"object","title":"TextUserMessageContentParts","required":["text"],"properties":{"text":{"type":"string","title":"Text","isRequired":true,"uniqueKey":"messages.items.[INDEX].oneOf.0.content.oneOf.1.items.[INDEX].oneOf.0.text","typeLabel":"string"},"type":{"type":"string","const":"text","title":"Type","default":"text","uniqueKey":"messages.items.[INDEX].oneOf.0.content.oneOf.1.items.[INDEX].oneOf.0.type","typeLabel":"string"}},"uniqueKey":"messages.items.[INDEX].oneOf.0.content.oneOf.1.items.[INDEX].oneOf.0","typeLabel":"TextUserMessageContentParts · object"},{"type":"object","title":"ImageUrlUserMessageContentParts","required":["image_url"],"properties":{"image_url":{"properties":{"url":{"type":"string","title":"Url","description":"The URL of the image. Note: only OpenAI supports this.","isRequired":true,"uniqueKey":"messages.items.[INDEX].oneOf.0.content.oneOf.1.items.[INDEX].oneOf.1.image_url.url","typeLabel":"string"},"detail":{"title":"Detail","description":"Only used for OpenAI. Corresponds to OpenAI's image detail parameter.","type":"string","enum":["low","high","auto"],"uniqueKey":"messages.items.[INDEX].oneOf.0.content.oneOf.1.items.[INDEX].oneOf.1.image_url.detail","typeLabel":"enum\u003cstring>"}},"type":"object","required":["url"],"title":"ImageUrlSubPart","description":"Specifies the image URL and level of detail. Only supported by OpenAI models","isRequired":true,"uniqueKey":"messages.items.[INDEX].oneOf.0.content.oneOf.1.items.[INDEX].oneOf.1.image_url","typeLabel":"ImageUrlSubPart · object"},"type":{"type":"string","const":"image_url","title":"Type","default":"image_url","uniqueKey":"messages.items.[INDEX].oneOf.0.content.oneOf.1.items.[INDEX].oneOf.1.type","typeLabel":"string"}},"uniqueKey":"messages.items.[INDEX].oneOf.0.content.oneOf.1.items.[INDEX].oneOf.1","typeLabel":"ImageUrlUserMessageContentParts · object"},{"type":"object","title":"ImageDataUserMessageContentParts","required":["image_data"],"properties":{"image_data":{"properties":{"media_type":{"type":"string","title":"Media Type","description":"The media/mime type of the image data. For example, 'image/png'. Check providers' documentation for supported media types.","isRequired":true,"uniqueKey":"messages.items.[INDEX].oneOf.0.content.oneOf.1.items.[INDEX].oneOf.2.image_data.media_type","typeLabel":"string"},"data":{"type":"string","title":"Data","description":"The base64-encoded image data.","isRequired":true,"uniqueKey":"messages.items.[INDEX].oneOf.0.content.oneOf.1.items.[INDEX].oneOf.2.image_data.data","typeLabel":"string"},"type":{"type":"string","const":"base64","title":"Type","description":"The type of the image data. Only base64 is supported.","default":"base64","uniqueKey":"messages.items.[INDEX].oneOf.0.content.oneOf.1.items.[INDEX].oneOf.2.image_data.type","typeLabel":"string"},"detail":{"title":"Detail","description":"Only used for OpenAI. Corresponds to OpenAI's image detail parameter.","type":"string","enum":["low","high","auto"],"uniqueKey":"messages.items.[INDEX].oneOf.0.content.oneOf.1.items.[INDEX].oneOf.2.image_data.detail","typeLabel":"enum\u003cstring>"}},"type":"object","required":["media_type","data"],"title":"ImageDataSubPart","description":"Specifies inline image data","isRequired":true,"uniqueKey":"messages.items.[INDEX].oneOf.0.content.oneOf.1.items.[INDEX].oneOf.2.image_data","typeLabel":"ImageDataSubPart · object"},"type":{"type":"string","const":"image_data","title":"Type","default":"image_data","uniqueKey":"messages.items.[INDEX].oneOf.0.content.oneOf.1.items.[INDEX].oneOf.2.type","typeLabel":"string"}},"uniqueKey":"messages.items.[INDEX].oneOf.0.content.oneOf.1.items.[INDEX].oneOf.2","typeLabel":"ImageDataUserMessageContentParts · object"}],"uniqueKey":"messages.items.[INDEX].oneOf.0.content.oneOf.1.items.[INDEX]","typeLabel":"TextUserMessageContentParts · object | ImageUrlUserMessageContentParts · object | ImageDataUserMessageContentParts · object"},"title":"Content","description":"Input from the user. Can either be text or a list of content parts. Not all models support image content parts, or multiple parts.","isRequired":true,"uniqueKey":"messages.items.[INDEX].oneOf.0.content.oneOf.1","typeLabel":"(TextUserMessageContentParts · object | ImageUrlUserMessageContentParts · object | ImageDataUserMessageContentParts · object)[]"}],"isRequired":true,"uniqueKey":"messages.items.[INDEX].oneOf.0.content","typeLabel":"string | (TextUserMessageContentParts · object | ImageUrlUserMessageContentParts · object | ImageDataUserMessageContentParts · object)[]"},"role":{"type":"string","const":"user","title":"Role","description":"The role of the message. Must be set to 'user'.\n\nA user message is a message from the user to the AI. This should be the message used to send end user input to the AI.","default":"user","uniqueKey":"messages.items.[INDEX].oneOf.0.role","typeLabel":"string"}},"uniqueKey":"messages.items.[INDEX].oneOf.0","typeLabel":"User Message · object"},{"type":"object","title":"Tool Message","required":["name","content"],"properties":{"name":{"type":"string","title":"Name","description":"Name of the tool","isRequired":true,"uniqueKey":"messages.items.[INDEX].oneOf.1.name","typeLabel":"string"},"content":{"type":"string","title":"Content","description":"Text output from the tool","isRequired":true,"uniqueKey":"messages.items.[INDEX].oneOf.1.content","typeLabel":"string"},"role":{"type":"string","const":"tool","title":"Role","description":"The role of the message. Must be set to 'tool'.\n\nA tool message is a message the client application uses to send tool output to the AI. It should contain the name of the tool and the output from the tool encoded as text.","default":"tool","uniqueKey":"messages.items.[INDEX].oneOf.1.role","typeLabel":"string"}},"uniqueKey":"messages.items.[INDEX].oneOf.1","typeLabel":"Tool Message · object"},{"type":"object","title":"Agent Message","properties":{"role":{"type":"string","const":"agent","title":"Role","description":"The role of the message. Must be set to 'agent'.\n\nAn agent message is a message generated by an AI agent. It is different than an assistant message in that it can either contain a direct content output or a tool request that the client application must handle.","default":"agent","uniqueKey":"messages.items.[INDEX].oneOf.2.role","typeLabel":"string"},"content":{"title":"Content","description":"Text output of the agent if no more tools are needed.","type":"string","uniqueKey":"messages.items.[INDEX].oneOf.2.content","typeLabel":"string"},"tool_request":{"properties":{"name":{"type":"string","title":"Name","description":"Name of the tool that the AI wants the client to use.","isRequired":true,"uniqueKey":"messages.items.[INDEX].oneOf.2.tool_request.name","typeLabel":"string"},"arguments":{"type":"string","title":"Arguments","description":"Arguments to pass to the tool. The format must be a JSON Schema-compliant object serialized into a string.","isRequired":true,"uniqueKey":"messages.items.[INDEX].oneOf.2.tool_request.arguments","typeLabel":"string"}},"type":"object","required":["name","arguments"],"title":"ToolRequest","description":"The tool request if the agent needs more information.","uniqueKey":"messages.items.[INDEX].oneOf.2.tool_request","typeLabel":"ToolRequest · object"}},"uniqueKey":"messages.items.[INDEX].oneOf.2","typeLabel":"Agent Message · object"},{"type":"object","title":"System Message","required":["content"],"properties":{"content":{"type":"string","title":"Content","description":"Text input from the system.","isRequired":true,"uniqueKey":"messages.items.[INDEX].oneOf.3.content","typeLabel":"string"},"role":{"type":"string","const":"system","title":"Role","description":"The role of the message. Must be set to 'system'.\n\nA system message is different from other messages in that it does not originate from a party engaged in a user/AI conversation. Instead, it is a message that is injected by either the application or system to guide the conversation. For example, a system message may be used as initial instructions for an AI entity or to tell the AI that it did not do something correctly.","default":"system","uniqueKey":"messages.items.[INDEX].oneOf.3.role","typeLabel":"string"}},"uniqueKey":"messages.items.[INDEX].oneOf.3","typeLabel":"System Message · object"},{"type":"object","title":"Assistant Message","required":["content"],"properties":{"content":{"type":"string","title":"Content","description":"Text response from the assistant","isRequired":true,"uniqueKey":"messages.items.[INDEX].oneOf.4.content","typeLabel":"string"},"role":{"type":"string","const":"assistant","title":"Role","description":"The role of the message. Must be set to 'assistant'.\n\nAn assistant message is a message from the AI to the client. It is different from an agent message in that it cannot contain a tool request. It is simply a direct response from the AI to the client.","default":"assistant","uniqueKey":"messages.items.[INDEX].oneOf.4.role","typeLabel":"string"}},"uniqueKey":"messages.items.[INDEX].oneOf.4","typeLabel":"Assistant Message · object"}],"uniqueKey":"messages.items.[INDEX]","typeLabel":"User Message · object | Tool Message · object | Agent Message · object | System Message · object | Assistant Message · object"},"type":"array","title":"Messages","description":"The list of messages in the conversation.\n\nExpand each message type to see how it works and when to use it. Most conversations should begin with a single `user` message.","isRequired":true,"uniqueKey":"messages","typeLabel":"(User Message · object | Tool Message · object | Agent Message · object | System Message · object | Assistant Message · object)[]"},"memory_strategy":{"properties":{"params":{"properties":{"k":{"type":"integer","minimum":1,"title":"K","description":"The maximum number of previous messages to remember.","isRequired":true,"uniqueKey":"memory_strategy.params.k","typeLabel":"integer"}},"type":"object","required":["k"],"title":"LastKMemoryStrategyParams","description":"Configuration parameters for the memory strategy.","isRequired":true,"uniqueKey":"memory_strategy.params","typeLabel":"LastKMemoryStrategyParams · object"},"name":{"type":"string","const":"last_k","title":"Name","description":"Name of the memory strategy. Must be `last_k`.\n\nThis strategy truncates the message history to the last `k` messages. It is the simplest way to prevent the model's context limit from being exceeded. However, this strategy only allows the model to have short term memory. For longer term memory, please use one of the other strategies.","default":"last_k","uniqueKey":"memory_strategy.name","typeLabel":"string"}},"type":"object","required":["params"],"title":"MemoryStrategy","description":"The memory strategy to use for the agent. A memory strategy is a way to prevent the underlying LLM's context limit from being exceeded. Each memory strategy uses a different technique to condense the input message list into a smaller payload for the underlying LLM.\n\nWe only support the Last K memory strategy right now, but will be adding new strategies soon.","uniqueKey":"memory_strategy","typeLabel":"MemoryStrategy · object"},"model_parameters":{"properties":{"temperature":{"title":"Temperature","description":"What sampling temperature to use, between [0, 1]. Higher values like 0.8 will make the output more random, while lower values like 0.2 will make it more focused and deterministic. Setting temperature=0.0 will enable fully deterministic (greedy) sampling. Temperature is ignored for OpenAI reasoning models.","default":0.2,"type":"number","maximum":1,"minimum":0,"uniqueKey":"model_parameters.temperature","typeLabel":"number"},"stop_sequences":{"title":"Stop Sequences","description":"List of up to 4 sequences where the API will stop generating further tokens. The returned text will not contain the stop sequence.","items":{"type":"string","uniqueKey":"model_parameters.stop_sequences.items.[INDEX]","typeLabel":"string"},"type":"array","maxItems":4,"uniqueKey":"model_parameters.stop_sequences","typeLabel":"string[]"},"max_tokens":{"title":"Max Tokens","description":"The maximum number of tokens to generate in the completion. The token count of your prompt plus max_tokens cannot exceed the model's context length. If not, specified, max_tokens will be determined based on the model used: \n| Model API family | Model API default | EGP applied default |\n| --- | --- | --- |\n| OpenAI Completions | [`16`](https://platform.openai.com/docs/api-reference/completions/create#max_tokens) | `context window - prompt size` |\n| OpenAI Chat Completions | [`context window - prompt size`](https://platform.openai.com/docs/api-reference/chat/create#max_tokens) | `context window - prompt size` |\n| LLM Engine | [`max_new_tokens`](https://github.com/scaleapi/launch-python-client/blob/207adced1c88c1c2907266fa9dd1f1ff3ec0ea5b/launch/client.py#L2910) parameter is required | `100` |\n| Anthropic Claude 2 | [`max_tokens_to_sample`](https://docs.anthropic.com/claude/reference/complete_post) parameter is required | `10000` |\n","type":"integer","uniqueKey":"model_parameters.max_tokens","typeLabel":"integer"},"topP":{"title":"Topp","description":"The cumulative probability cutoff for token selection. Lower values mean sampling from a smaller, more top-weighted nucleus. Available for models from Anthropic, Google, Mistral, LLM Engine, and OpenAI.","type":"number","uniqueKey":"model_parameters.topP","typeLabel":"number"},"topK":{"title":"Topk","description":"Sample from the k most likely next tokens at each step. Lower k focuses on higher probability tokens. Available for models from Anthropic, Google, and LLM Engine.","type":"integer","uniqueKey":"model_parameters.topK","typeLabel":"integer"},"frequency_penalty":{"title":"Frequency Penalty","description":"Penalize tokens based on how much they have already appeared in the text. Positive values encourage the model to generate new tokens and negative values encourage the model to repeat tokens. Available for models from LLM Engine, and OpenAI","type":"number","uniqueKey":"model_parameters.frequency_penalty","typeLabel":"number"},"presence_penalty":{"title":"Presence Penalty","description":"Penalize tokens based on if they have already appeared in the text. Positive values encourage the model to generate new tokens and negative values encourage the model to repeat tokens. Available for models from LLM Engine, and OpenAI.","type":"number","uniqueKey":"model_parameters.presence_penalty","typeLabel":"number"},"reasoning_effort":{"title":"Reasoning Effort","description":"The effort level for the model to reason. Available for models from OpenAI.","type":"string","enum":["low","medium","high"],"uniqueKey":"model_parameters.reasoning_effort","typeLabel":"enum\u003cstring>"}},"type":"object","title":"ModelParameters","description":"Configuration parameters for the agent model, such as temperature, max_tokens, and stop_sequences.\n\nIf not specified, the default value are:\n- temperature: 0.2\n- max_tokens: None (limited by the model's max tokens)\n- stop_sequences: None","default":{"temperature":0.2},"uniqueKey":"model_parameters","typeLabel":"ModelParameters · object"},"instructions":{"title":"Instructions","description":"The initial instructions to provide to the agent.\n\nUse this to guide the agent to act in more specific ways. For example, if you have specific rules you want to restrict the agent to follow you can specify them here. For example, if I want the agent to always use certain tools before others, I can write that rule in these instructions.\n\nGood prompt engineering is crucial to getting performant results from the agent. If you are having trouble getting the agent to perform well, try writing more specific instructions here before trying more expensive techniques such as swapping in other models or finetuning the underlying LLM.","default":"You are an AI assistant that helps users with their questions. You can answer questions directly or acquire information from any of the attached tools to assist you. Always answer the user's most recent query to the best of your knowledge.\n\nWhen asked about what tools are available, you must list each attached tool's name and description. When asked about what you can do, mention that in addition to your normal capabilities, you can also use the attached tools by listing their names and descriptions. You cannot use any other tools other than the ones provided to you explicitly.","type":"string","uniqueKey":"instructions","typeLabel":"string"}},"type":"object","required":["model","tools","messages"],"title":"ExecuteAgentRequest","uniqueKey":"","typeLabel":"ExecuteAgentRequest · object"},"examples":{"Example":{"title":"Example","value":{"tools":[{"name":"\u003cstring>","description":"\u003cstring>","arguments":{"type":"object","properties":{},"required":["\u003cstring>"]}}],"messages":[{"content":"\u003cstring>","role":"user"}],"model_parameters":{"temperature":0.2},"instructions":"You are an AI assistant that helps users with their questions. You can answer questions directly or acquire information from any of the attached tools to assist you. Always answer the user's most recent query to the best of your knowledge.\n\nWhen asked about what tools are available, you must list each attached tool's name and description. When asked about what you can do, mention that in addition to your normal capabilities, you can also use the attached tools by listing their names and descriptions. You cannot use any other tools other than the ones provided to you explicitly."}}},"exampleType":"generated"}},"required":true,"exampleType":"generated"},"responses":{"d71e2d2e-a617-45ed-9902-84d68288cbcc":{"description":"Successful Response","content":{"application/json":{"schema":{"properties":{"action":{"type":"string","enum":["tool_request","content"],"title":"AgentAction","description":"The action that the agent performed.\n\nThe context will contain a key for each action that the agent can perform. However, only the key corresponding to the action that the agent actually performed will have a populated value. The rest of the values will be `null`.","isRequired":true,"uniqueKey":"action","typeLabel":"enum\u003cstring>"},"context":{"properties":{"content":{"title":"Content","description":"The final output of the agent when it no longer needs any tools","type":"string","uniqueKey":"context.content","typeLabel":"string"},"tool_request":{"properties":{"name":{"type":"string","title":"Name","description":"Name of the tool that the AI wants the client to use.","isRequired":true,"uniqueKey":"context.tool_request.name","typeLabel":"string"},"arguments":{"type":"string","title":"Arguments","description":"Arguments to pass to the tool. The format must be a JSON Schema-compliant object serialized into a string.","isRequired":true,"uniqueKey":"context.tool_request.arguments","typeLabel":"string"}},"type":"object","required":["name","arguments"],"title":"ToolRequest","description":"The tool request if the agent needs more information.","uniqueKey":"context.tool_request","typeLabel":"ToolRequest · object"}},"type":"object","title":"ActionContext","description":"Context object containing the output payload. This will contain a key for all actions that the agent can perform. However, only the key corresponding to the action that the agent performed have a populated value. The rest of the values will be `null`.","isRequired":true,"uniqueKey":"context","typeLabel":"ActionContext · object"}},"type":"object","required":["action","context"],"title":"ExecuteAgentResponse","uniqueKey":"","typeLabel":"ExecuteAgentResponse · object"},"examples":{"Example":{"title":"Example","value":{"action":"tool_request","context":{"content":"\u003cstring>","tool_request":{"name":"\u003cstring>","arguments":"\u003cstring>"}}}}},"exampleType":"generated"}},"exampleType":"generated"},"2d9fd935-c102-451c-aae8-7940c77f237d":{"description":"Validation Error","content":{"application/json":{"schema":{"properties":{"detail":{"items":{"properties":{"loc":{"items":{"oneOf":[{"type":"string","uniqueKey":"detail.items.[INDEX].loc.items.[INDEX].oneOf.0","typeLabel":"string"},{"type":"integer","uniqueKey":"detail.items.[INDEX].loc.items.[INDEX].oneOf.1","typeLabel":"integer"}],"uniqueKey":"detail.items.[INDEX].loc.items.[INDEX]","typeLabel":"string | integer"},"type":"array","title":"Location","isRequired":true,"uniqueKey":"detail.items.[INDEX].loc","typeLabel":"(string | integer)[]"},"msg":{"type":"string","title":"Message","isRequired":true,"uniqueKey":"detail.items.[INDEX].msg","typeLabel":"string"},"type":{"type":"string","title":"Error Type","isRequired":true,"uniqueKey":"detail.items.[INDEX].type","typeLabel":"string"},"input":{"oneOf":[{"title":"Input"}],"uniqueKey":"detail.items.[INDEX].input","typeLabel":"any"},"ctx":{"type":"object","title":"Context","additionalProperties":true,"uniqueKey":"detail.items.[INDEX].ctx","typeLabel":"Context · object"}},"type":"object","required":["loc","msg","type"],"title":"ValidationError","uniqueKey":"detail.items.[INDEX]","typeLabel":"ValidationError · object"},"type":"array","title":"Detail","uniqueKey":"detail","typeLabel":"ValidationError · object[]"}},"type":"object","title":"HTTPValidationError","uniqueKey":"","typeLabel":"HTTPValidationError · object"},"examples":{"Example":{"title":"Example","value":{"detail":[{"loc":["\u003cstring>"],"msg":"\u003cstring>","type":"\u003cstring>","input":"\u003cunknown>","ctx":{}}]}}},"exampleType":"generated"}},"exampleType":"generated"}},"security":{},"servers":{"239d3ed0-e9a1-4424-90ea-9274ea35b5d0":{"url":"https://api.egp.scale.com"}}},"originalFileLocation":"https://api.sgp.scale.com/openapi-versions/v4/openapi.json"},"subdomain":"scalegp","siteName":"Scale AI","title":"Execute Agent - Scale AI","navMaps":{"firstHrefInVersion":{"V5":{"href":"/docs/v5/agents/overview","matchLevel":2},"V4 (legacy)":{"href":"/reference/v4/agents/execute-agent","matchLevel":0}},"firstHrefInLanguage":{}},"lastModified":"2026-05-29T12:48:38.387Z","originalFileLocation":"reference/v4/agents/execute-agent.mdx"},"headHtml":"\u003cscript data-mint-head>(function(){var d=document.documentElement,p=null;if(!p){try{p=localStorage.getItem(\"isDarkMode\")}catch(e){}if(p==='true')p='dark';else if(p==='false')p='light';if(p!=='light'\u0026\u0026p!=='dark'\u0026\u0026p!=='system')p=\"system\"}var r=p==='system'?(matchMedia(\"(prefers-color-scheme: dark)\").matches?'dark':'light'):p;d.classList.remove(r==='dark'?'light':'dark');d.classList.add(r);d.setAttribute(\"data-theme-preference\",p)})();\u003c/script>\u003cmeta data-mint-head name=\"description\" content=\"### Description Executes one Agent inference step. Given a list of messages and a list of tools to ask for help from, the Agent will either respond with a final answer directly or ask the user to execute a tool to provide more information. ### Details An Agent is a component that utilizes a Language Model (LLM) as an interpreter and decision maker. Unlike asking an LLM for a direct response, communicating with an agent consists of a running dialogue where an agent can optionally ask the user to execute specialized tools for specific tasks, such as calculations, web searches, or accessing custom data from private knowledge bases. An agent is designed to be stateless, emitting outputs one step at a time. This means that client-side applications are responsible for managing message history, tool execution, and responses. This grants users greater flexibility to write and execute custom tools and maintain explicit control over their message history. #### Message Types - User Message: A message from the user to the agent. - System Message: An informational text message from the system to guide the agent. It is not a user message or agent message because it did not come from either entity. - Agent Message: A message from the agent to the client. It will contain either a final answer as content or a request for the user to execute a tool as a tool_request. - Tool Message: A message from the user to the agent that contains the output of a tool execution. The tool message will be processed by the agent and the agent will respond with either a final answer or another tool request. #### Agent Instructions Instructions are used to guide the agent\u0026#x27;s decision making process and output generation. Good prompt engineering is crucial to getting performant results from the agent. If you are having trouble getting the agent to perform well, try writing more specific instructions before trying more expensive techniques such as swapping in other models or finetuning the underlying LLM. For example, the default instructions we set for the agent are the following: \u0026gt; You are an AI assistant that helps users with their questions. You can answer questions directly or acquire information from any of the attached tools to assist you. Always answer the user\u0026#x27;s most recent query to the best of your knowledge. \u0026gt; When asked about what tools are available, you must list each attached tool\u0026#x27;s name and description. When asked about what you can do, mention that in addition to your normal capabilities, you can also use the attached tools by listing their names and descriptions. You cannot use any other tools other than the ones provided to you explicitly. ### Restrictions and Limits Message Limits: - The message list is not limited by length, but by the context limit of the underlying language model. If you are getting an error regarding the underlying model\u0026#x27;s context limit, try using a memory strategy to condense the input messages. Model Restrictions: - Currently, only closed source models like GPT and Claude are supported due to the limitations of open source models when it comes to tool selection, generating tool arguments in valid JSON, and planning out multi-step tool execution. Specialized fine-tuning will likely be required to make open source models compatible with agents.\">\u003cmeta data-mint-head name=\"application-name\" content=\"Scale AI\">\u003cmeta data-mint-head name=\"generator\" content=\"Mintlify\">\u003clink data-mint-head rel=\"icon\" type=\"image/png\" sizes=\"192x192\" href=\"/mintlify-assets/_mintlify/favicons/scalegp/UksUEh3sxckFW0X-/_generated/favicon/android-chrome-192x192.png\" media=\"(prefers-color-scheme: light)\">\u003clink data-mint-head rel=\"apple-touch-icon\" type=\"image/png\" sizes=\"180x180\" href=\"/mintlify-assets/_mintlify/favicons/scalegp/UksUEh3sxckFW0X-/_generated/favicon/apple-touch-icon.png\">\u003clink data-mint-head rel=\"icon\" type=\"image/png\" sizes=\"16x16\" href=\"/mintlify-assets/_mintlify/favicons/scalegp/UksUEh3sxckFW0X-/_generated/favicon/favicon-16x16.png\" media=\"(prefers-color-scheme: light)\">\u003clink data-mint-head rel=\"icon\" type=\"image/png\" sizes=\"32x32\" href=\"/mintlify-assets/_mintlify/favicons/scalegp/UksUEh3sxckFW0X-/_generated/favicon/favicon-32x32.png\" media=\"(prefers-color-scheme: light)\">\u003clink data-mint-head rel=\"shortcut icon\" type=\"image/x-icon\" href=\"/mintlify-assets/_mintlify/favicons/scalegp/UksUEh3sxckFW0X-/_generated/favicon/favicon.ico\" media=\"(prefers-color-scheme: light)\">\u003clink data-mint-head rel=\"icon\" type=\"image/png\" sizes=\"192x192\" href=\"/mintlify-assets/_mintlify/favicons/scalegp/UksUEh3sxckFW0X-/_generated/favicon-dark/android-chrome-192x192.png\" media=\"(prefers-color-scheme: dark)\">\u003clink data-mint-head rel=\"icon\" type=\"image/png\" sizes=\"16x16\" href=\"/mintlify-assets/_mintlify/favicons/scalegp/UksUEh3sxckFW0X-/_generated/favicon-dark/favicon-16x16.png\" media=\"(prefers-color-scheme: dark)\">\u003clink data-mint-head rel=\"icon\" type=\"image/png\" sizes=\"32x32\" href=\"/mintlify-assets/_mintlify/favicons/scalegp/UksUEh3sxckFW0X-/_generated/favicon-dark/favicon-32x32.png\" media=\"(prefers-color-scheme: dark)\">\u003clink data-mint-head rel=\"shortcut icon\" type=\"image/x-icon\" href=\"/mintlify-assets/_mintlify/favicons/scalegp/UksUEh3sxckFW0X-/_generated/favicon-dark/favicon.ico\" media=\"(prefers-color-scheme: dark)\">\u003cmeta data-mint-head property=\"og:title\" content=\"Execute Agent - Scale AI\">\u003cmeta data-mint-head property=\"og:description\" content=\"### Description Executes one Agent inference step. Given a list of messages and a list of tools to ask for help from, the Agent will either respond with a final answer directly or ask the user to execute a tool to provide more information. ### Details An Agent is a component that utilizes a Language Model (LLM) as an interpreter and decision maker. Unlike asking an LLM for a direct response, communicating with an agent consists of a running dialogue where an agent can optionally ask the user to execute specialized tools for specific tasks, such as calculations, web searches, or accessing custom data from private knowledge bases. An agent is designed to be stateless, emitting outputs one step at a time. This means that client-side applications are responsible for managing message history, tool execution, and responses. This grants users greater flexibility to write and execute custom tools and maintain explicit control over their message history. #### Message Types - User Message: A message from the user to the agent. - System Message: An informational text message from the system to guide the agent. It is not a user message or agent message because it did not come from either entity. - Agent Message: A message from the agent to the client. It will contain either a final answer as content or a request for the user to execute a tool as a tool_request. - Tool Message: A message from the user to the agent that contains the output of a tool execution. The tool message will be processed by the agent and the agent will respond with either a final answer or another tool request. #### Agent Instructions Instructions are used to guide the agent\u0026#x27;s decision making process and output generation. Good prompt engineering is crucial to getting performant results from the agent. If you are having trouble getting the agent to perform well, try writing more specific instructions before trying more expensive techniques such as swapping in other models or finetuning the underlying LLM. For example, the default instructions we set for the agent are the following: \u0026gt; You are an AI assistant that helps users with their questions. You can answer questions directly or acquire information from any of the attached tools to assist you. Always answer the user\u0026#x27;s most recent query to the best of your knowledge. \u0026gt; When asked about what tools are available, you must list each attached tool\u0026#x27;s name and description. When asked about what you can do, mention that in addition to your normal capabilities, you can also use the attached tools by listing their names and descriptions. You cannot use any other tools other than the ones provided to you explicitly. ### Restrictions and Limits Message Limits: - The message list is not limited by length, but by the context limit of the underlying language model. If you are getting an error regarding the underlying model\u0026#x27;s context limit, try using a memory strategy to condense the input messages. Model Restrictions: - Currently, only closed source models like GPT and Claude are supported due to the limitations of open source models when it comes to tool selection, generating tool arguments in valid JSON, and planning out multi-step tool execution. Specialized fine-tuning will likely be required to make open source models compatible with agents.\">\u003cmeta data-mint-head property=\"og:site_name\" content=\"Scale AI\">\u003cmeta data-mint-head property=\"og:url\" content=\"https://docs.gp.scale.com/reference/v4/agents/execute-agent\">\u003cmeta data-mint-head property=\"og:type\" content=\"website\">\u003cmeta data-mint-head property=\"og:image\" content=\"https://scalegp.mintlify.app/_mintlify/api/og/v2?division=Agents\u0026amp;title=Execute+Agent\u0026amp;description=%23%23%23+Description%0AExecutes+one+Agent+inference+step.+Given+a+list+of+messages+and+a+list+of+tools+to+ask+++++++++for+help+from%2C+the+Agent+will+either+respond+with\u0026amp;theme=b7e87dd2f9a2a23155199f59\u0026amp;signature=8f77de022128b0755944021476616a5422f29951bc9620b9682ef458d7fe334e\">\u003cmeta data-mint-head property=\"og:image:width\" content=\"1200\">\u003cmeta data-mint-head property=\"og:image:height\" content=\"630\">\u003cmeta data-mint-head name=\"twitter:card\" content=\"summary_large_image\">\u003cmeta data-mint-head name=\"twitter:title\" content=\"Execute Agent - Scale AI\">\u003cmeta data-mint-head name=\"twitter:description\" content=\"### Description Executes one Agent inference step. Given a list of messages and a list of tools to ask for help from, the Agent will either respond with a final answer directly or ask the user to execute a tool to provide more information. ### Details An Agent is a component that utilizes a Language Model (LLM) as an interpreter and decision maker. Unlike asking an LLM for a direct response, communicating with an agent consists of a running dialogue where an agent can optionally ask the user to execute specialized tools for specific tasks, such as calculations, web searches, or accessing custom data from private knowledge bases. An agent is designed to be stateless, emitting outputs one step at a time. This means that client-side applications are responsible for managing message history, tool execution, and responses. This grants users greater flexibility to write and execute custom tools and maintain explicit control over their message history. #### Message Types - User Message: A message from the user to the agent. - System Message: An informational text message from the system to guide the agent. It is not a user message or agent message because it did not come from either entity. - Agent Message: A message from the agent to the client. It will contain either a final answer as content or a request for the user to execute a tool as a tool_request. - Tool Message: A message from the user to the agent that contains the output of a tool execution. The tool message will be processed by the agent and the agent will respond with either a final answer or another tool request. #### Agent Instructions Instructions are used to guide the agent\u0026#x27;s decision making process and output generation. Good prompt engineering is crucial to getting performant results from the agent. If you are having trouble getting the agent to perform well, try writing more specific instructions before trying more expensive techniques such as swapping in other models or finetuning the underlying LLM. For example, the default instructions we set for the agent are the following: \u0026gt; You are an AI assistant that helps users with their questions. You can answer questions directly or acquire information from any of the attached tools to assist you. Always answer the user\u0026#x27;s most recent query to the best of your knowledge. \u0026gt; When asked about what tools are available, you must list each attached tool\u0026#x27;s name and description. When asked about what you can do, mention that in addition to your normal capabilities, you can also use the attached tools by listing their names and descriptions. You cannot use any other tools other than the ones provided to you explicitly. ### Restrictions and Limits Message Limits: - The message list is not limited by length, but by the context limit of the underlying language model. If you are getting an error regarding the underlying model\u0026#x27;s context limit, try using a memory strategy to condense the input messages. Model Restrictions: - Currently, only closed source models like GPT and Claude are supported due to the limitations of open source models when it comes to tool selection, generating tool arguments in valid JSON, and planning out multi-step tool execution. Specialized fine-tuning will likely be required to make open source models compatible with agents.\">\u003cmeta data-mint-head name=\"twitter:image\" content=\"https://scalegp.mintlify.app/_mintlify/api/og/v2?division=Agents\u0026amp;title=Execute+Agent\u0026amp;description=%23%23%23+Description%0AExecutes+one+Agent+inference+step.+Given+a+list+of+messages+and+a+list+of+tools+to+ask+++++++++for+help+from%2C+the+Agent+will+either+respond+with\u0026amp;theme=b7e87dd2f9a2a23155199f59\u0026amp;signature=8f77de022128b0755944021476616a5422f29951bc9620b9682ef458d7fe334e\">\u003cmeta data-mint-head name=\"twitter:image:width\" content=\"1200\">\u003cmeta data-mint-head name=\"twitter:image:height\" content=\"630\">\u003cmeta data-mint-head name=\"msapplication-config\" content=\"/mintlify-assets/_mintlify/favicons/scalegp/UksUEh3sxckFW0X-/_generated/favicon/browserconfig.xml\">\u003cmeta data-mint-head name=\"apple-mobile-web-app-title\" content=\"Scale AI\">\u003cmeta data-mint-head name=\"msapplication-TileColor\" content=\"#3f2e7b\">\u003clink data-mint-head rel=\"canonical\" href=\"https://docs.gp.scale.com/reference/v4/agents/execute-agent\">\u003clink data-mint-head rel=\"alternate\" type=\"application/xml\" href=\"/sitemap.xml\">\u003clink data-mint-head rel=\"alternate\" type=\"text/markdown\" href=\"/reference/v4/agents/execute-agent.md\">\u003cscript data-mint-head type=\"application/ld+json\">{\"@context\":\"https://schema.org\",\"@graph\":[{\"@type\":\"Organization\",\"@id\":\"https://docs.gp.scale.com/#organization\",\"name\":\"Scale AI\",\"url\":\"https://docs.gp.scale.com\",\"logo\":{\"@type\":\"ImageObject\",\"url\":\"https://mintcdn.com/scalegp/TBmst1qiYXwYqUB5/logo/light.png?fit=max\u0026auto=format\u0026n=TBmst1qiYXwYqUB5\u0026q=85\u0026s=46027042c16b373ac463148db5ad1d6b\"}},{\"@type\":\"WebSite\",\"@id\":\"https://docs.gp.scale.com#website\",\"name\":\"Scale AI\",\"url\":\"https://docs.gp.scale.com\",\"publisher\":{\"@id\":\"https://docs.gp.scale.com/#organization\"}},{\"@type\":\"WebPage\",\"@id\":\"https://docs.gp.scale.com/reference/v4/agents/execute-agent#webpage\",\"url\":\"https://docs.gp.scale.com/reference/v4/agents/execute-agent\",\"name\":\"Execute Agent\",\"description\":\"### Description Executes one Agent inference step. Given a list of messages and a list of tools to ask for help from, the Agent will either respond with a final answer directly or ask the user to execute a tool to provide more information. ### Details An Agent is a component that utilizes a Language Model (LLM) as an interpreter and decision maker. Unlike asking an LLM for a direct response, communicating with an agent consists of a running dialogue where an agent can optionally ask the user to execute specialized tools for specific tasks, such as calculations, web searches, or accessing custom data from private knowledge bases. An agent is designed to be stateless, emitting outputs one step at a time. This means that client-side applications are responsible for managing message history, tool execution, and responses. This grants users greater flexibility to write and execute custom tools and maintain explicit control over their message history. #### Message Types - User Message: A message from the user to the agent. - System Message: An informational text message from the system to guide the agent. It is not a user message or agent message because it did not come from either entity. - Agent Message: A message from the agent to the client. It will contain either a final answer as content or a request for the user to execute a tool as a tool_request. - Tool Message: A message from the user to the agent that contains the output of a tool execution. The tool message will be processed by the agent and the agent will respond with either a final answer or another tool request. #### Agent Instructions Instructions are used to guide the agent's decision making process and output generation. Good prompt engineering is crucial to getting performant results from the agent. If you are having trouble getting the agent to perform well, try writing more specific instructions before trying more expensive techniques such as swapping in other models or finetuning the underlying LLM. For example, the default instructions we set for the agent are the following: > You are an AI assistant that helps users with their questions. You can answer questions directly or acquire information from any of the attached tools to assist you. Always answer the user's most recent query to the best of your knowledge. > When asked about what tools are available, you must list each attached tool's name and description. When asked about what you can do, mention that in addition to your normal capabilities, you can also use the attached tools by listing their names and descriptions. You cannot use any other tools other than the ones provided to you explicitly. ### Restrictions and Limits Message Limits: - The message list is not limited by length, but by the context limit of the underlying language model. If you are getting an error regarding the underlying model's context limit, try using a memory strategy to condense the input messages. Model Restrictions: - Currently, only closed source models like GPT and Claude are supported due to the limitations of open source models when it comes to tool selection, generating tool arguments in valid JSON, and planning out multi-step tool execution. Specialized fine-tuning will likely be required to make open source models compatible with agents.\",\"dateModified\":\"2026-05-29T12:48:38.387Z\",\"isPartOf\":{\"@id\":\"https://docs.gp.scale.com#website\"},\"breadcrumb\":{\"@id\":\"https://docs.gp.scale.com/reference/v4/agents/execute-agent#breadcrumb\"}},{\"@type\":\"BreadcrumbList\",\"@id\":\"https://docs.gp.scale.com/reference/v4/agents/execute-agent#breadcrumb\",\"itemListElement\":[{\"@type\":\"ListItem\",\"position\":1,\"name\":\"Scale AI\",\"item\":\"https://docs.gp.scale.com\"},{\"@type\":\"ListItem\",\"position\":2,\"name\":\"Execute Agent\",\"item\":\"https://docs.gp.scale.com/reference/v4/agents/execute-agent\"}]},{\"@type\":[\"TechArticle\",\"APIReference\"],\"@id\":\"https://docs.gp.scale.com/reference/v4/agents/execute-agent#apireference\",\"headline\":\"Execute Agent\",\"name\":\"Execute Agent\",\"description\":\"### Description Executes one Agent inference step. Given a list of messages and a list of tools to ask for help from, the Agent will either respond with a final answer directly or ask the user to execute a tool to provide more information. ### Details An Agent is a component that utilizes a Language Model (LLM) as an interpreter and decision maker. Unlike asking an LLM for a direct response, communicating with an agent consists of a running dialogue where an agent can optionally ask the user to execute specialized tools for specific tasks, such as calculations, web searches, or accessing custom data from private knowledge bases. An agent is designed to be stateless, emitting outputs one step at a time. This means that client-side applications are responsible for managing message history, tool execution, and responses. This grants users greater flexibility to write and execute custom tools and maintain explicit control over their message history. #### Message Types - User Message: A message from the user to the agent. - System Message: An informational text message from the system to guide the agent. It is not a user message or agent message because it did not come from either entity. - Agent Message: A message from the agent to the client. It will contain either a final answer as content or a request for the user to execute a tool as a tool_request. - Tool Message: A message from the user to the agent that contains the output of a tool execution. The tool message will be processed by the agent and the agent will respond with either a final answer or another tool request. #### Agent Instructions Instructions are used to guide the agent's decision making process and output generation. Good prompt engineering is crucial to getting performant results from the agent. If you are having trouble getting the agent to perform well, try writing more specific instructions before trying more expensive techniques such as swapping in other models or finetuning the underlying LLM. For example, the default instructions we set for the agent are the following: > You are an AI assistant that helps users with their questions. You can answer questions directly or acquire information from any of the attached tools to assist you. Always answer the user's most recent query to the best of your knowledge. > When asked about what tools are available, you must list each attached tool's name and description. When asked about what you can do, mention that in addition to your normal capabilities, you can also use the attached tools by listing their names and descriptions. You cannot use any other tools other than the ones provided to you explicitly. ### Restrictions and Limits Message Limits: - The message list is not limited by length, but by the context limit of the underlying language model. If you are getting an error regarding the underlying model's context limit, try using a memory strategy to condense the input messages. Model Restrictions: - Currently, only closed source models like GPT and Claude are supported due to the limitations of open source models when it comes to tool selection, generating tool arguments in valid JSON, and planning out multi-step tool execution. Specialized fine-tuning will likely be required to make open source models compatible with agents.\",\"url\":\"https://docs.gp.scale.com/reference/v4/agents/execute-agent\",\"mainEntityOfPage\":{\"@id\":\"https://docs.gp.scale.com/reference/v4/agents/execute-agent#webpage\"},\"dateModified\":\"2026-05-29T12:48:38.387Z\",\"publisher\":{\"@id\":\"https://docs.gp.scale.com/#organization\"},\"isPartOf\":{\"@id\":\"https://docs.gp.scale.com#website\"}}]}\u003c/script>","siteName":"Scale AI","nav":{"global":null,"versions":[{"version":"V5","pages":[{"title":"V5","href":"/docs/v5/agents/overview"}]},{"version":"V4 (legacy)","tabs":[{"tab":"Home","pages":[{"title":"Home","href":"/home"}]},{"tab":"Guides","pages":[{"title":"Guides","href":"/docs/introduction"}]},{"tab":"API Reference","groups":[{"group":"Knowledge Bases","pages":[{"title":"List Knowledge Bases","deprecated":null,"version":null,"openapi":"https://api.sgp.scale.com/openapi-versions/v4/openapi.json get /v4/knowledge-bases","href":"/reference/v4/knowledge-bases/list-knowledge-bases"},{"title":"Create Knowledge Base","deprecated":null,"version":null,"openapi":"https://api.sgp.scale.com/openapi-versions/v4/openapi.json post /v4/knowledge-bases","href":"/reference/v4/knowledge-bases/create-knowledge-base"},{"title":"Get Knowledge Base","deprecated":null,"version":null,"openapi":"https://api.sgp.scale.com/openapi-versions/v4/openapi.json get /v4/knowledge-bases/{knowledge_base_id}","href":"/reference/v4/knowledge-bases/get-knowledge-base"},{"title":"Delete Knowledge Base","deprecated":null,"version":null,"openapi":"https://api.sgp.scale.com/openapi-versions/v4/openapi.json delete /v4/knowledge-bases/{knowledge_base_id}","href":"/reference/v4/knowledge-bases/delete-knowledge-base"},{
[...]
